--[[-----------------------------------------------------------------

EnergyMonitor Options

Initial Creation Date: 2008/11/15
Description: Load on demand module for EnergyMonitor menus

Author: lokicoyote
File Date: 2008-12-04T22:43:43Z
File Revision: 71
Project Revision: 73
Project Version: v0.10.4

--]]-----------------------------------------------------------------

assert(LibStub)

local kAddon = "EnergyMonitor"
local kModule = "Options"

-- Cache often used global functions
local setmetatable = _G.setmetatable

local parent_addon = LibStub("AceAddon-3.0"):GetAddon(kAddon)
EnergyMonitor_Options = parent_addon:NewModule(kModule)

---------------------------------------------------------------------
-- Library constants
---------------------------------------------------------------------

local addon = parent_addon:GetModule(kModule)

---------------------------------------------------------------------
-- AceAddon IMPLEMENTED functions
---------------------------------------------------------------------

function addon:OnInitialize()
	self.addon = parent_addon
	self.cache = setmetatable({}, { __mode = "v" })
	self.var = {}

	self:setupOptions()
end

function addon:OnEnable()
	local SharedMedia = LibStub:GetLibrary("LibSharedMedia-3.0", true)
	if SharedMedia then
		SharedMedia.RegisterCallback(self, "LibSharedMedia_Register")
	end
	if self.addon.chatCommand ~= self.ChatCommand then
		-- Store the old chat command
		self.var.chatCommand = self.addon.chatCommand
		-- Replace with our _C_hatCommand
		self.addon.chatCommand = self.ChatCommand
	end
end

function addon:OnDisable()
	local SharedMedia = LibStub:GetLibrary("LibSharedMedia-3.0", true)
	if SharedMedia then
		SharedMedia.UnregisterAllCallbacks(self)
	end
	if self.addon.chatCommand == self.ChatCommand then
		-- Replace the original chatCommand
		self.addon.chatCommand = self.var.chatCommand
	end
end
